package com.jeeplus.modules.sg.scheduleView.web;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.sg.managementcenter.activiti.utils.MyActiviUtils;
import com.jeeplus.modules.sg.scheduleView.entity.*;
import com.jeeplus.modules.sg.scheduleView.service.ScheduleViewService;
import org.activiti.engine.history.HistoricActivityInstance;
import org.activiti.engine.task.Task;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@RequestMapping(value = "${adminPath}/scheduleView")
public class ScheduleViewController extends BaseController {
    @Autowired
    private ScheduleViewService scheduleViewService;


    /**
     * 模块查看所有项目信息
     */
    @RequestMapping(value = "allView")
    public String form(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/scheduleView";
    }

    /**
     * 施工交底项目模块
     */
    @RequestMapping(value = "disView")
    public String disView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/disView";
    }

    /**
     * 物资领料模块
     */
    @RequestMapping(value = "recView")
    public String recView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/recView";
    }

    /**
     * 结算模块
     */
    @RequestMapping(value = "settView")
    public String settView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/settView";
    }

    /**
     * 设计进度
     */
    @RequestMapping(value = "designView")
    public String designView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/designView";
    }

    /**
     * 项目关闭进度
     */
    @RequestMapping(value = "closureView")
    public String closureView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/closureView";
    }

    /**
     * 政策处理进度
     */
    @RequestMapping(value = "policyView")
    public String policyView(ScheduleView scheduleView, Model model) {
        model.addAttribute("scheduleView", scheduleView);
        return "modules/sg/scheduleView/show/policyView";
    }

    /**
     * 大体项目所有信息
     */
    @ResponseBody
    @RequestMapping(value = "allData")
    public Map<String, Object> useQuantityData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model) {
        //获取查询的项目定义号
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            //根据空格分割
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        //查询所有项目信息
        Page<ScheduleView> scheduleViewPage = scheduleViewService.scheduleProjectAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        for (ScheduleView c : list) {
            String status = c.getStatus();
            String acquisitionStatus = c.getAcquisitionStatus();
            String constructionStatus = c.getConstructionStatus();
            String settStatus = c.getSettStatus();
            //对不同流程状态进行判断重新赋值
            if ("0".equalsIgnoreCase(status)) {
                c.setStatus("未发起流程");
            } else if ("1".equalsIgnoreCase(status)) {
                c.setStatus("发起流程中");
            } else {
                c.setStatus("流程结束");
            }

            if ("0".equalsIgnoreCase(acquisitionStatus)) {
                c.setAcquisitionStatus("未发起流程");
            } else if ("1".equalsIgnoreCase(acquisitionStatus)) {
                c.setAcquisitionStatus("发起流程中");
            } else {
                c.setAcquisitionStatus("流程结束");
            }
            if ("0".equalsIgnoreCase(constructionStatus)) {
                c.setConstructionStatus("未发起流程");
            } else if ("1".equalsIgnoreCase(constructionStatus)) {
                c.setConstructionStatus("发起流程中");
            } else {
                c.setConstructionStatus("流程结束");
            }
            if ("0".equalsIgnoreCase(settStatus)) {
                c.setSettStatus("未发起流程");
            } else if ("1".equalsIgnoreCase(status)) {
                c.setSettStatus("发起流程中");
            } else {
                c.setSettStatus("流程结束");
            }
        }
        return getBootstrapData(scheduleViewPage);
    }


    /**
     * 施工交底项目列表
     */
    @ResponseBody
    @RequestMapping(value = "disData")
    public Map<String, Object> disData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model) {
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.disAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String fin = "";
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            String clarificaitonType = s.getClarificaitonType();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                List<Task> tasks = MyActiviUtils.runNowTask(procInsId);
                String runNowName = "";
                for (Task a : tasks) {
                    runNowName += a.getName();
                }
                for (HistoricActivityInstance a : historicActivityInstances) {
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if (s.getDisView() == null) {
                        s.setDisView(new DisView());
                    }
                    if ("开始".equals(activityName)) {
                        DisView disView = s.getDisView();
                        if (disView != null) {
                            s.getDisView().setFullTimeStart(format);
                        } else {
                            DisView disView1 = new DisView();
                            disView1.setFullTimeStart(format);
                            s.setDisView(disView1);
                        }
                    }
                    if ("施工单位自行交底".equals(clarificaitonType)) {
                        s.getDisView().setProjectManagerImport("施工单位交底没有此流程");
                        if ("交底:施工单位组织交底".equals(activityName)) {
                            s.getDisView().setUnitManagerJudge(format);
                        }
                        if ("交底:项目经理人工判断问题".equals(activityName)) {
                            s.getDisView().setProjectManagerJudge(format);
                            if (runNowName.contains("交底:判定设计变更")
                                    || runNowName.contains("交底:项目经理判断是否需要再设计变更")
                                    || runNowName.contains("交底:经研所设计变更")
                                    || runNowName.contains("交底:运行人员审核图纸")
                                    || runNowName.contains("交底:重新设计")
                                    || runNowName.contains("交底:运行人员判断变更后材料")
                                    || runNowName.contains("交底:配网项目经理判断变更后材料")
                                    || runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")
                                    || runNowName.contains("交底:项目经理判断是否需要政策处理")
                                    || runNowName.contains("交底:施工方案盖章")
                                    || runNowName.contains("交底:上传收据")
                                    || runNowName.contains("交底:上传缴费单")
                                    || runNowName.contains("交底:上传借款单据")
                                    || runNowName.contains("交底:判断政策处理")
                                    || runNowName.contains("交底:上传未签字版政策处理清单")
                                    || runNowName.contains("交底:项目经理判断农村是否需要政策处理")
                                    || runNowName.contains("交底:上传签字版政策处理清单")
                                    || runNowName.contains("交底:上传签字版合同")
                                    || runNowName.contains("交底:上传借款单据1")
                                    || runNowName.contains("交底:判断项目是否需要关闭")
                                    || runNowName.contains("交底:配网运行人员")
                                    || runNowName.contains("交底:确认项目关闭")) {
                                if (runNowName.contains("交底:判定设计变更")
                                        || runNowName.contains("交底:项目经理判断是否需要再设计变更")
                                        || runNowName.contains("交底:经研所设计变更")
                                        || runNowName.contains("交底:运行人员审核图纸")
                                        || runNowName.contains("交底:重新设计")
                                        || runNowName.contains("交底:运行人员判断变更后材料")
                                        || runNowName.contains("交底:配网项目经理判断变更后材料")) {
                                    if (runNowName.contains("交底:判定设计变更")) {
                                        s.getDisView().setDesignChange("交底:判定设计变更");
                                    }
                                    if (runNowName.contains("交底:项目经理判断是否需要再设计变更")) {
                                        s.getDisView().setDesignChange("交底:项目经理判断是否需要再设计变更");
                                    }
                                    if (runNowName.contains("交底:经研所设计变更")) {
                                        s.getDisView().setDesignChange("交底:经研所设计变更");
                                    }
                                    if (runNowName.contains("交底:运行人员审核图纸")) {
                                        s.getDisView().setDesignChange("交底:运行人员审核图纸");
                                    }
                                    if (runNowName.contains("交底:重新设计")) {
                                        s.getDisView().setDesignChange("交底:重新设计");
                                    }
                                    if (runNowName.contains("交底:运行人员判断变更后材料")) {
                                        s.getDisView().setDesignChange("交底:运行人员判断变更后材料");
                                    }
                                    if (runNowName.contains("交底:配网项目经理判断变更后材料")) {
                                        s.getDisView().setDesignChange("交底:配网项目经理判断变更后材料");
                                    }
                                }
                                if (runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")
                                        || runNowName.contains("交底:项目经理判断是否需要政策处理")
                                        || runNowName.contains("交底:施工方案盖章")
                                        || runNowName.contains("交底:上传收据")
                                        || runNowName.contains("交底:上传缴费单")
                                        || runNowName.contains("交底:上传借款单据")
                                        || runNowName.contains("交底:判断政策处理")
                                        || runNowName.contains("交底:上传未签字版政策处理清单")
                                        || runNowName.contains("交底:项目经理判断农村是否需要政策处理")
                                        || runNowName.contains("交底:上传签字版政策处理清单")
                                        || runNowName.contains("交底:上传签字版合同")
                                        || runNowName.contains("交底:上传借款单据1")) {
                                    String info = "";
                                    if (runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")) {
                                        info += "交底:上传未盖章施工方案(行政政处(城区道路));";
                                    }
                                    if (runNowName.contains("交底:项目经理判断是否需要政策处理")) {
                                        info += "交底:项目经理判断是否需要政策处理;";
                                    }
                                    if (runNowName.contains("交底:施工方案盖章")) {
                                        info += "交底:施工方案盖章;";
                                    }
                                    if (runNowName.contains("交底:上传收据")) {
                                        info += "交底:上传收据;";
                                    }
                                    if (runNowName.contains("交底:上传缴费单")) {
                                        info += "交底:上传缴费单;";
                                    }
                                    if (runNowName.contains("交底:上传借款单据")) {
                                        info += "交底:上传借款单据;";
                                    }
                                    if (runNowName.contains("交底:判断政策处理")) {
                                        info += "交底:判断政策处理;";
                                    }
                                    if (runNowName.contains("交底:上传未签字版政策处理清单")) {
                                        info += "交底:上传未签字版政策处理清单;";
                                    }
                                    if (runNowName.contains("交底:项目经理判断农村是否需要政策处理")) {
                                        info += "交底:项目经理判断农村是否需要政策处理;";
                                    }
                                    if (runNowName.contains("交底:上传签字版政策处理清单")) {
                                        info += "交底:上传签字版政策处理清单;";
                                    }
                                    if (runNowName.contains("交底:上传签字版合同")) {
                                        info += "交底:上传签字版合同;";
                                    }
                                    if (runNowName.contains("交底:上传借款单据1")) {
                                        info += "交底:农村上传借款单据;";
                                    }
                                    s.getDisView().setPolicyType(info);
                                }
                                if (runNowName.contains("交底:判断项目是否需要关闭")
                                        || runNowName.contains("交底:配网运行人员")
                                        || runNowName.contains("交底:确认项目关闭")) {
                                    if (runNowName.contains("交底:判断项目是否需要关闭")) {
                                        s.getDisView().setProjectClosure("交底:判断项目是否需要关闭");
                                    }
                                    if (runNowName.contains("交底:配网运行人员")) {
                                        s.getDisView().setProjectClosure("交底:配网运行人员");
                                    }
                                    if (runNowName.contains("交底:确认项目关闭")) {
                                        s.getDisView().setProjectClosure("交底:确认项目关闭");
                                    }
                                }
                            }
                        }

                        if ("交底:配网项目经理判断变更后材料".equals(activityName)) {
                            s.getDisView().setDesignChange(format);
                        }
                        if ("交底:上传借款单据".equals(activityName)) {
                            s.getDisView().setPolicyType(format);
                        }
                        if ("交底:上传借款单据1".equals(activityName)) {
                            s.getDisView().setPolicyType(format);
                        }
                        if ("交底:确认项目关闭".equals(activityName)) {
                            s.getDisView().setProjectClosure(format);
                        }
                    } else {
                        s.getDisView().setUnitManagerJudge("项目组织交底没有此流程");
                        s.getDisView().setProjectManagerImport("项目组织交底没有此流程");
                        //项目经理组织交底后
                        if ("交底:项目经理组织交底".equals(activityName)||"交底:项目经理人工审核问题".equals(activityName)||"交底:项目经理人工判断问题".equals(activityName)) {
                            s.getDisView().setProjectManagerImport(format);
                        }
                        if (runNowName!=null || !runNowName.equals("")) {
                        if (runNowName.contains("交底:判定设计变更")
                                || runNowName.contains("交底:项目经理判断是否需要再设计变更")
                                || runNowName.contains("交底:经研所设计变更")
                                || runNowName.contains("交底:运行人员审核图纸")
                                || runNowName.contains("交底:重新设计")
                                || runNowName.contains("交底:运行人员判断变更后材料")
                                || runNowName.contains("交底:配网项目经理判断变更后材料")
                                || runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")
                                || runNowName.contains("交底:项目经理判断是否需要政策处理")
                                || runNowName.contains("交底:施工方案盖章")
                                || runNowName.contains("交底:上传收据")
                                || runNowName.contains("交底:上传缴费单")
                                || runNowName.contains("交底:上传借款单据")
                                || runNowName.contains("交底:判断政策处理")
                                || runNowName.contains("交底:上传未签字版政策处理清单")
                                || runNowName.contains("交底:项目经理判断农村是否需要政策处理")
                                || runNowName.contains("交底:上传签字版政策处理清单")
                                || runNowName.contains("交底:上传签字版合同")
                                || runNowName.contains("交底:上传借款单据1")
                                || runNowName.contains("交底:判断项目是否需要关闭")
                                || runNowName.contains("交底:配网运行人员")
                                || runNowName.contains("交底:确认项目关闭")) {
                            if (runNowName.contains("交底:判定设计变更")
                                    || runNowName.contains("交底:项目经理判断是否需要再设计变更")
                                    || runNowName.contains("交底:经研所设计变更")
                                    || runNowName.contains("交底:运行人员审核图纸")
                                    || runNowName.contains("交底:重新设计")
                                    || runNowName.contains("交底:运行人员判断变更后材料")
                                    || runNowName.contains("交底:配网项目经理判断变更后材料")) {
                                if (runNowName.contains("交底:判定设计变更")) {
                                    s.getDisView().setDesignChange("交底:判定设计变更");
                                }
                                if (runNowName.contains("交底:项目经理判断是否需要再设计变更")) {
                                    s.getDisView().setDesignChange("交底:项目经理判断是否需要再设计变更");
                                }
                                if (runNowName.contains("交底:经研所设计变更")) {
                                    s.getDisView().setDesignChange("交底:经研所设计变更");
                                }
                                if (runNowName.contains("交底:运行人员审核图纸")) {
                                    s.getDisView().setDesignChange("交底:运行人员审核图纸");
                                }
                                if (runNowName.contains("交底:重新设计")) {
                                    s.getDisView().setDesignChange("交底:重新设计");
                                }
                                if (runNowName.contains("交底:运行人员判断变更后材料")) {
                                    s.getDisView().setDesignChange("交底:运行人员判断变更后材料");
                                }
                                if (runNowName.contains("交底:配网项目经理判断变更后材料")) {
                                    s.getDisView().setDesignChange("交底:配网项目经理判断变更后材料");
                                }
                            }
                            if (runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")
                                    || runNowName.contains("交底:项目经理判断是否需要政策处理")
                                    || runNowName.contains("交底:施工方案盖章")
                                    || runNowName.contains("交底:上传收据")
                                    || runNowName.contains("交底:上传缴费单")
                                    || runNowName.contains("交底:上传借款单据")
                                    || runNowName.contains("交底:判断政策处理")
                                    || runNowName.contains("交底:上传未签字版政策处理清单")
                                    || runNowName.contains("交底:项目经理判断农村是否需要政策处理")
                                    || runNowName.contains("交底:上传签字版政策处理清单")
                                    || runNowName.contains("交底:上传签字版合同")
                                    || runNowName.contains("交底:上传借款单据1")) {
                                String info = "";
                                if (runNowName.contains("交底:上传未盖章施工方案(行政政处(城区道路))")) {
                                    info += "交底:上传未盖章施工方案(行政政处(城区道路));";
                                }
                                if (runNowName.contains("交底:项目经理判断是否需要政策处理")) {
                                    info += "交底:项目经理判断是否需要政策处理;";
                                }
                                if (runNowName.contains("交底:施工方案盖章")) {
                                    info += "交底:施工方案盖章;";
                                }
                                if (runNowName.contains("交底:上传收据")) {
                                    info += "交底:上传收据;";
                                }
                                if (runNowName.contains("交底:上传缴费单")) {
                                    info += "交底:上传缴费单;";
                                }
                                if (runNowName.contains("交底:上传借款单据")) {
                                    info += "交底:上传借款单据;";
                                }
                                if (runNowName.contains("交底:判断政策处理")) {
                                    info += "交底:判断政策处理;";
                                }
                                if (runNowName.contains("交底:上传未签字版政策处理清单")) {
                                    info += "交底:上传未签字版政策处理清单;";
                                }
                                if (runNowName.contains("交底:项目经理判断农村是否需要政策处理")) {
                                    info += "交底:项目经理判断农村是否需要政策处理;";
                                }
                                if (runNowName.contains("交底:上传签字版政策处理清单")) {
                                    info += "交底:上传签字版政策处理清单;";
                                }
                                if (runNowName.contains("交底:上传签字版合同")) {
                                    info += "交底:上传签字版合同;";
                                }
                                if (runNowName.contains("交底:上传借款单据1")) {
                                    info += "交底:农村上传借款单据;";
                                }
                                s.getDisView().setPolicyType(info);
                            }
                            if (runNowName.contains("交底:判断项目是否需要关闭")
                                    || runNowName.contains("交底:配网运行人员")
                                    || runNowName.contains("交底:确认项目关闭")) {
                                if (runNowName.contains("交底:判断项目是否需要关闭")) {
                                    s.getDisView().setProjectClosure("交底:判断项目是否需要关闭");
                                }
                                if (runNowName.contains("交底:配网运行人员")) {
                                    s.getDisView().setProjectClosure("交底:配网运行人员");
                                }
                                if (runNowName.contains("交底:确认项目关闭")) {
                                    s.getDisView().setProjectClosure("交底:确认项目关闭");
                                }
                            }
                        }
                        }
                        if ("交底:配网项目经理判断变更后材料".equals(activityName)) {
                            s.getDisView().setDesignChange(format);
                        }
                        if ("交底:上传借款单据".equals(activityName)) {
                            s.getDisView().setPolicyType(format);
                        }
                        if ("交底:上传借款单据1".equals(activityName)) {
                            s.getDisView().setPolicyType(format);
                        }
                        if ("交底:确认项目关闭".equals(activityName)) {
                            s.getDisView().setProjectClosure(format);
                        }
                    }
                    //
                    if ("交底:配网项目经理判断变更后材料".equals(activityName)
                            || "交底:上传借款单据".equals(activityName)
                            || "交底:上传借款单据1".equals(activityName)
                            || "交底:确认项目关闭".equals(activityName)) {
                        if (fin.equals("")) {
                            fin = format;
                        }
                        if ( fin.compareTo(format) < 1) {
                            fin = format;
                        }
                    }
                }
                if ("2".equals(s.getStatus())) {
                    s.getDisView().setFinTime(fin);
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }

    @ResponseBody
    @RequestMapping(value = "recData")
    public Map<String, Object> recData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model){
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.recAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                List<Task> tasks = MyActiviUtils.runNowTask(procInsId);
                for (HistoricActivityInstance a : historicActivityInstances) {
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if (s.getReceiveView() == null) {
                        s.setReceiveView(new ReceiveView());
                    }
                    if ("项目经理开领料单".equals(activityName)) {
                        s.getReceiveView().setOpenList(format);
                    }
                    if ("领料:经理填写项目模块".equals(activityName)) {
                        s.getReceiveView().setMangagerFile(format);
                    }
                    if ("领料:施工单位领导审核".equals(activityName)) {
                        s.getReceiveView().setMaLeaderReviewed(format);
                    }
                    if ("领料:施工单位物资专职审核".equals(activityName)) {
                        s.getReceiveView().setConUnitReviewed(format);
                    }
                    if ("领料:配网项目经理审核领料单".equals(activityName)) {
                        s.getReceiveView().setConMangagerReviewed(format);
                    }
                    if ("领料:配网物资专职审核领料单".equals(activityName)) {
                        s.getReceiveView().setFullReviewed(format);
                    }
                    if ("领料:项目中心领导审核领料单".equals(activityName)) {
                        s.getReceiveView().setLeaderReviewed(format);
                        s.getReceiveView().setRecFinTime(format);
                    }
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }

    /**
     * 结算流程数据
     * */
    @ResponseBody
    @RequestMapping(value = "settData")
    public Map<String, Object> settData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model){
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.setAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                for (HistoricActivityInstance a: historicActivityInstances) {
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if (s.getSettView() == null) {
                        s.setSettView(new SettView());
                    }
                    if ("结算验收发起模块".equals(activityName)) {
                        s.getSettView().setSettStart(format);
                    }
                    if ("填写现场使用数量".equals(activityName)) {
                        s.getSettView().setSettNumber(format);
                    }
                    if ("审计现场复核数量".equals(activityName)) {
                        s.getSettView().setSettReview(format);
                    }
                    if ("生成领料退料单".equals(activityName)) {
                        s.getSettView().setSettFin(format);
                    }
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }

    /**
     * 项目关闭数据列表
     */
    @ResponseBody
    @RequestMapping(value = "closureData")
    public Map<String, Object> closureData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model) {
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.disAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                for (HistoricActivityInstance a : historicActivityInstances) {
                    if (s.getClosureView() == null) {
                        s.setClosureView(new ClosureView());
                    }
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if ("交底:判断项目是否需要关闭".equals(activityName)) {
                        s.getClosureView().setIfClose(format);
                    }
                    if ("交底:配网运行人员".equals(activityName)) {
                        s.getClosureView().setRunMember(format);
                    }
                    if ("交底:确认项目关闭".equals(activityName)) {
                        s.getClosureView().setIsClosed(format);
                    }
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }

    /**
     * 项目关闭数据列表
     */
    @ResponseBody
    @RequestMapping(value = "designData")
    public Map<String, Object> designData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model) {
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.disAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                for (HistoricActivityInstance a : historicActivityInstances) {
                    if (s.getDesignView() == null) {
                        s.setDesignView(new DesignView());
                    }
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if ("交底:判定设计变更".equals(activityName)) {
                        s.getDesignView().setDesignChange(format);
                    }
                    if ("交底:项目经理判断是否需要再设计变更".equals(activityName)) {
                        s.getDesignView().setIfChange(format);
                    }
                    if ("交底:经研所设计变更".equals(activityName)) {
                        s.getDesignView().setJYSChange(format);
                    }
                    if ("交底:运行人员审核图纸".equals(activityName)) {
                        s.getDesignView().setUnitReview(format);
                    }
                    if ("交底:重新设计".equals(activityName)) {
                        s.getDesignView().setDesignAgain(format);
                    }
                    if ("交底:运行人员判断变更后材料".equals(activityName)) {
                        s.getDesignView().setChangeAfter(format);
                    }
                    if ("交底:配网项目经理判断变更后材料".equals(activityName)) {
                        s.getDesignView().setManagerAfter(format);
                    }
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }

    /**
     * 政策处理数据列表
     */
    @ResponseBody
    @RequestMapping(value = "policyData")
    public Map<String, Object> policyData(ScheduleView scheduleView, HttpServletRequest request, HttpServletResponse response, Model model) {
        String projectId = scheduleView.getProjectId();
        String[] projectList = null;
        List<String> searchList = new ArrayList<>();
        if (!projectId.equals("")) {
            projectList = projectId.split("\\s+");
            for (int i = 0; i < projectList.length; i++) {
                searchList.add(projectList[i]);
            }
            scheduleView.setProjectList(searchList);
        }
        Page<ScheduleView> scheduleViewPage = scheduleViewService.disAll(new Page<ScheduleView>(request, response), scheduleView);
        List<ScheduleView> list = scheduleViewPage.getList();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (ScheduleView s : list) {
            String procInsId = s.getProcInsId();
            if (procInsId != null && !"".equals(procInsId)) {
                List<HistoricActivityInstance> historicActivityInstances = MyActiviUtils.hisTask(procInsId);
                for (HistoricActivityInstance a : historicActivityInstances) {
                    if (s.getPolicyView() == null) {
                        s.setPolicyView(new PolicyView());
                    }
                    String activityName = a.getActivityName();
                    String format = formatter.format(a.getEndTime());
                    if ("交底:上传未盖章施工方案(行政政处(城区道路))".equals(activityName)) {
                        s.getPolicyView().setUrbanRoad(format);
                    }
                    if ("交底:项目经理判断是否需要政策处理".equals(activityName)) {
                        s.getPolicyView().setPolicyNeed(format);
                    }
                    if ("交底:施工方案盖章".equals(activityName)) {
                        s.getPolicyView().setSealScheme(format);
                    }
                    if ("交底:上传收据".equals(activityName)) {
                        s.getPolicyView().setUploadReceipt(format);
                    }
                    if ("交底:上传缴费单".equals(activityName)) {
                        s.getPolicyView().setPayment(format);
                    }
                    if ("交底:上传借款单据".equals(activityName)) {
                        s.getPolicyView().setUploadLoan(format);
                    }
                    if ("交底:判断政策处理".equals(activityName)) {
                        s.getPolicyView().setHandling(format);
                    }
                    if ("交底:上传未签字版政策处理清单".equals(activityName)) {
                        s.getPolicyView().setUnsignedVersion(format);
                    }
                    if ("交底:项目经理判断农村是否需要政策处理".equals(activityName)) {
                        s.getPolicyView().setRuralNeed(format);
                    }
                    if ("交底:上传签字版政策处理清单".equals(activityName)) {
                        s.getPolicyView().setPolicyList(format);
                    }
                    if ("交底:上传签字版合同".equals(activityName)) {
                        s.getPolicyView().setSignedContract(format);
                    }
                    if ("交底:上传借款单据1".equals(activityName)) {
                        s.getPolicyView().setUploadLoan1(format);
                    }
                }
            }
        }
        return getBootstrapData(scheduleViewPage);
    }
    /* *//**
     * 导出excel文件
     *//*
    @ResponseBody
    @RequestMapping(value = "exportSett")
    public AjaxJson exportSett(SettList settList, HttpServletRequest request, HttpServletResponse response){
        AjaxJson j = new AjaxJson();
        try {
            String fileName = "竣工甲供材核对表"+DateUtils.getDate("yyyyMMddHHmmss")+".xlsx";
            Page<SettList> page = settActiviService.useQuantityData(new Page<SettList>(request, response), settList);
            new ExportExcel("竣工甲供材核对表", SettList.class).setDataList(page.getList()).write(response, fileName).dispose();
            j.setSuccess(true);
            j.setMsg("导出成功！");
            return j;
        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导出需求基本信息记录失败！失败信息："+e.getMessage());
        }
        return j;
    }*/
}


