<%@ page contentType="text/html;charset=UTF-8" %>
<script>
$(document).ready(function() {
	$('#dataTable').bootstrapTable({
		 
		  //请求方法
               method: 'post',
               //类型json
               dataType: "json",
               contentType: "application/x-www-form-urlencoded",
               //显示检索按钮
	           showSearch: true,
               //显示刷新按钮
               showRefresh: true,
               //显示切换手机试图按钮
               showToggle: true,
               //显示 内容列下拉框
    	       showColumns: true,
    	       //显示到处按钮
    	       showExport: true,
    	       //显示切换分页按钮
    	       showPaginationSwitch: true,
    	       //最低显示2行
    	       minimumCountColumns: 2,
               //是否显示行间隔色
               striped: true,
               //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）     
               cache: false,    
               //是否显示分页（*）  
               pagination: true,   
                //排序方式 
               sortOrder: "asc",  
               //初始化加载第一页，默认第一页
               pageNumber:1,   
               //每页的记录行数（*）   
               pageSize: 10,  
               //可供选择的每页的行数（*）    
               pageList: [10, 25, 50, 100],
               //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据  
               url: "${ctx}/sg/financial/expense/data",
               //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
               //queryParamsType:'',   
               ////查询参数,每次调用是会带上这个参数，可自定义                         
               queryParams : function(params) {
               	var searchParam = $("#searchForm").serializeJSON();
               	searchParam.pageNo = params.limit === undefined? "1" :params.offset/params.limit+1;
               	searchParam.pageSize = params.limit === undefined? -1 : params.limit;
               	searchParam.orderBy = params.sort === undefined? "" : params.sort+ " "+  params.order;
                   return searchParam;
               },
               //分页方式：client客户端分页，server服务端分页（*）
               sidePagination: "server",
               contextMenuTrigger:"right",//pc端 按右键弹出菜单
               contextMenuTriggerMobile:"press",//手机端 弹出菜单，click：单击， press：长按。
               contextMenu: '#context-menu',
               onContextMenuItem: function(row, $el){
               },
              
               onClickRow: function(row, $el){
               },
               	onShowSearch: function () {
			$("#search-collapse").slideToggle();
		},
               columns: [{
		        checkbox: true
		    },{
                   field: 'projectId',
                   width:230,
                   title: '项目定义号'
               }
			,{
		        field: 'projectName',
                width:120,
		        title: '项目名称'
		    },{
                   field: 'projectBatch',
                   width:120,
                   title: '项目批次'
               }
		    ,{
               field: 'constructionCost',
               width:160,
               title: '施工费合同折扣'

           }
		    ,{
               field: 'designCost',
               width:120,
               title: '设计费合同折扣'
           }
           ,{
               field: 'designTypeicalCost',
               width:120,
               title: '设计费典型设计折扣'
           }
           ,{
               field: 'supervisionCost',
               width:120,
               title: '监理费合同折扣'
           }
           ,{
               field: 'supervisionTypeicalCost',
               width:120,
               title: '监理费典型折扣'
           }
           ,{
               field: 'documentDesignCost',
               width:120,
               title: '发文中设计费金额（不含税）'
           }
           ,{
               field: 'documentSupervisionCost',
               width:120,
               title: '发文中监理费金额（不含税）'
           }
         ]
		});
		
		  
	  if(navigator.userAgent.match(/(iPhone|iPod|Android|ios)/i)){//如果是移动端

		 
		  $('#dataTable').bootstrapTable("toggleView");
		}
	  
	  $('#dataTable').on('check.bs.table uncheck.bs.table load-success.bs.table ' +
                'check-all.bs.table uncheck-all.bs.table', function () {
            $('#remove').prop('disabled', ! $('#dataTable').bootstrapTable('getSelections').length);
            $('#view,#edit').prop('disabled', $('#dataTable').bootstrapTable('getSelections').length!=1);
        });
		  

		


		    
	  $("#search").click("click", function() {// 绑定查询按扭
		  $('#dataTable').bootstrapTable('refresh');
		});
	 
	 $("#reset").click("click", function() {// 绑定查询按扭
		  $("#searchForm  input").val("");
		  $("#searchForm  select").val("");
		  $("#searchForm  .select-item").html("");
		  $('#dataTable').bootstrapTable('refresh');
		});

    $("#import").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title:"导入数据",
            content: "${ctx}/tag/importExcel" ,
            btn: ['下载模板','确定', '关闭'],
            btn1: function(index, layero){
                jp.downloadFile('${ctx}/sg/financial/expense/templates');
            },
            btn2: function(index, layero){
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/sg/financial/expense/importExpense', function (data) {
                    top.layer.msg(data.msg, {icon:1})
                    refresh()
                    jp.close(index);
                });//调用保存事件
                return false;
            },
            btn3: function(index){
                jp.close(index);
            }
        })
    })


		
	});
		
  function getIdSelections() {
        return $.map($("#dataTable").bootstrapTable('getSelections'), function (row) {
            return row.id
        });
    }
  
  function deleteAll(){

		jp.confirm('确认要删除该数据记录吗？', function(){
			jp.loading();  	
			jp.get("${ctx}/sg/settlement/deleteAll?ids=" + getIdSelections(), function(data){
         	  		if(data.success){
         	  			$('#dataTable').bootstrapTable('refresh');
         	  			jp.success(data.msg);
         	  		}else{
         	  			jp.error(data.msg);
         	  		}
         	  	})
          	   
		})
  }

    //刷新列表
  function refresh(){
  	$('#dataTable').bootstrapTable('refresh');
  }
  
   function add(){
	  jp.openSaveDialog('新增', "${ctx}/sg/financial/expense/addForm",'800px', '500px');
  }


  
   function edit(id){//没有权限时，不显示确定按钮
       if(id == undefined){
	      id = getIdSelections();
	}
	jp.openSaveDialog('编辑', "${ctx}/sg/financial/expense/editForm?id=" + id, '800px', '500px');
  }

    function deleteAll(){

        jp.confirm('确认要删除该数据记录吗？', function(){
            jp.loading();
            jp.get("${ctx}/sg/financial/expense/deleteAll?ids=" + getIdSelections(), function(data){
                if(data.success){
                    $('#dataTable').bootstrapTable('refresh');
                    jp.success(data.msg);
                }else{
                    jp.error(data.msg);
                }
            })

        })
    }

</script>