<%@ page contentType="text/html;charset=UTF-8" %>
<%@ include file="/webpage/include/taglib.jsp" %>
<html>
<head>
    <title>是否支付</title>
    <meta name="decorator" content="ani"/>
    <%@include file="/webpage/include/summernote.jsp" %>
    <script type="text/javascript">
        $(document).ready(function () {
            $("#conditions").click(function () {
                var val = $("#ifBorrow").val();
                jp.prompt("审核通过", function (message) {
                    jp.post("${ctx}/act/task/ruralPays",
                        {
                            "taskId": "${construction.act.taskId}",
                            "taskName": "${construction.act.taskName}",
                            "taskDefKey": "${construction.act.taskDefKey}",
                            "procInsId": "${construction.act.procInsId}",
                            "procDefId": "${construction.act.procDefId}",
                            "reserveProjectName": "${construction.reserveProjectName}",
                            "flag": "yes",
                            "comment": window.encodeURI(message)
                        },
                        function (data) {
                            if (data.success) {
                                jp.success(data.msg);
                                jp.go("${ctx}/act/task/todo")
                            }
                        }
                    )
                });
            });
        });
    </script>
</head>
<body>
<div class="wrapper wrapper-content">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-primary">
                <div class="panel-heading">
                    <h3 class="panel-title">
                        <h3 class="panel-title">是否支付</h3>
                    </h3>
                </div>
                <div class="panel-body">
                    <form:form id="inputForm" modelAttribute="construction" action="${ctx}/managementcenter/divide/save"
                               method="post" class="form-horizontal">
                        <form:hidden path="id"/>
                        <input id="procInsId" type="hidden" value="${fns:unescapeHtml(construction.procInsId)}">
                        <input type="hidden" value="${fns:unescapeHtml(construction.id)}">
                        <table class="table table-bordered">
                            <tbody>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">储备项目暂定名称：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.reserveProjectName)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">项目号：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.projectId)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">项目名称：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.projectName)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">市公司：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.municipalCompany)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 县公司：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.countyCompany)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">项目性质：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.projectNature)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 需求单位：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.demandUnit)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">运维单位：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.operationUnit)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 供电区域：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.powerSupplyArea)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">网格编号：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.gridNumber)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 单元格编号：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.cellNumber)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">项目储备编号：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.projectReserveNo)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">电网项目编号</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.gridProjectNo)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> ERP编号</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.erpNo)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">建设必要性及内容：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.necessityContent)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 变电站名称：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.subStationName)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">线路名称：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.lineName)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">项目类型：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.projectType)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否迎峰度夏项目：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.whetherSummer)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 项目基本说明：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.basicDescription)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">工区备注：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.basicInformation.workAreaRemarks)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">是否已实施：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.hasImplemented)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 现场情况描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.sceneDescription)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">是否有实施必要性：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.isImplement)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 实施无必要描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.noImplementation)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">图纸是否完整：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.whetherComplete)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 图纸完整性描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.drawingDescription)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">图纸是否规范：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.whetherStandard)}
                                </td>
                                <td class="width-15 active"><label class="pull-right"> 图纸规范性描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.normativeDrawings)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">是否存在典设图问题：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.whetherDrawing)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">典设图问题描述</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.problemDescription)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 是否存在施工通道</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.whetherChannel)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">施工通道情况描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.constructionDescription)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 土建是否需要调整：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.civilAdjusted)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">土建方案变更内容描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.descriptionPlans)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">土建工作量调整内容描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.descriptionAdjustment)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">电气方案是否需要调整：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.electricalAdjusted)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 调整原因描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.adjustmentDescription)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">自动化是否需要变更：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.doesChange)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 自动化方案调整内容：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.automatedContent)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">自动化工作内容调整：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.automatedAdjustment)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 其他方案是否需要调整：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.otherAdjusted)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">其他方案调整原因描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.descriptionReasons)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否存在难以解决的政处：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.difficultResolve)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否需要进行设计变更：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.designChanges)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否需要进行项目关闭：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.needsClosed)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">政处问题描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.affairsDescription)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否需要规划报批：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.planningRequired)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否涉及高铁、高速：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.highSpeed)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否存在复杂民事政处：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.affairsOffice)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">图纸方案是否存在前置条件：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.preconditions)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 前置条件描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.preconditionDescription)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否需要定制物资：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.customizedMaterials)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否能定制：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.customizedCan)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">定制原因描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.reasonDescription)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 定制物资描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.materialDescription)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">拆旧物资是否与设计一致：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.demolitionMaterials)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 型号不一致描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.modelDescription)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">数量不一致描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.quantityDescription)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 图纸标注是否存在问题：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.drawingAnnotation)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">图纸标注问题描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.drawingProblem)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否存在停电问题：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.powerOutage)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">停电问题问题描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.powerProblem)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否邻近带电线路：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.nearLiveLine)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否下穿高压线路：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.highVoltageLine)}
                                </td>
                            </tr>
                            <tr>

                                <td class="width-15 active"><label class="pull-right"> 是否存在复杂管线：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.complexPipeline)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否涉及复杂停电：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.disclose.complicatedPower)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 是否含自动化：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.includeAutomation)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">通信方式：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.wayOf)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 作业方式：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.assignmentStyle)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否含变电站新间隔投运：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.operationSubstation)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 是否需调整命名编号：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.namingNumber)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否存在土建验收：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.engineeringAcceptance)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 是否存在电气验收：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.electricalAcceptance)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">停电线路：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.blackoutLine)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right">停电范围初步校核 ：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.outageRange)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">是否存在政策处理问题：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.policyIssues)}
                                </td>
                            </tr>
                            <tr>
                                <td class="width-15 active"><label class="pull-right"> 政策处理类型：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.processingType)}
                                </td>
                                <td class="width-15 active"><label class="pull-right">政策处理描述：</label></td>
                                <td class="width-35">
                                        ${fns:unescapeHtml(construction.quantity.processingDescription)}
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </form:form>
                    <div class="row">
                        <div class="col-sm-3"></div>
                        <div class="col-sm-6">
                            <div class="form-group text-center">
                                <input id="conditions" class="btn  btn-primary btn-lg btn-parsley" type="submit"
                                       value="通过"/>&nbsp;
                            </div>
                        </div>
                    </div>

                    <c:if test="${not empty construction.id}">
                        <act:flowChart procInsId="${construction.act.procInsId}"/>
                        <act:histoicFlow procInsId="${construction.act.procInsId}"/>
                    </c:if>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>