<%@ page contentType="text/html;charset=UTF-8" %>
<%@ include file="/webpage/include/taglib.jsp"%>
<html>
<head>
	<title>年度物资上报统计</title>
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<meta name="decorator" content="ani"/>
	<%@ include file="/webpage/include/bootstraptable.jsp"%>
	<%@include file="/webpage/include/treeview.jsp" %>
	<%@include file="materialProjectList.js" %>
</head>
<body>
	<div class="wrapper wrapper-content">
	<div class="panel panel-primary">
	<div class="panel-heading">
		<h3 class="panel-title">年度物资上报统计</h3>
	</div>
	<div class="panel-body">
	
	<!-- 搜索 -->
	<div id="search-collapse" class="collapse">
		<div class="accordion-inner">
			<form:form id="searchForm" modelAttribute="materialProject" class="form form-horizontal well clearfix">
			    <div class="col-xs-12 col-sm-6 col-md-4">
				   <label class="label-item single-overflow pull-left" title="储备项目暂定名称：">储备项目暂定名称：</label>
				   <form:input path="reserveProjectName" htmlEscape="false" maxlength="64"  class=" form-control"/>
			    </div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="储备编码：">储备编码：</label>
					<form:input path="reserveCode" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目类型：">项目类型：</label>
					<form:input path="projectType" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目计划年度批次：">项目计划年度批次：</label>
					<form:input path="batchPlan" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目正式发文批次：">项目正式发文批次：</label>
					<form:input path="issuePlan" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目年度实施计划：">项目年度实施计划：</label>
					<form:input path="monthPlan" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="年度计划有无预测：">年度计划有无预测：</label>
					<form:input path="hasPlan" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目物资执行计划：">项目物资执行计划：</label>
					<form:input path="halfPlan" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目定义：">项目定义：</label>
					<form:input path="projectId" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				<div class="col-xs-12 col-sm-6 col-md-4">
					<label class="label-item single-overflow pull-left" title="项目名称：">项目名称：</label>
					<form:input path="projectName" htmlEscape="false" maxlength="64"  class=" form-control"/>
				</div>
				 <div class="col-xs-12 col-sm-6 col-md-4">
					<div style="margin-top:26px">
					  <a  id="search" class="btn btn-primary btn-rounded  btn-bordered btn-sm"><i class="fa fa-search"></i> 查询</a>
					  <a  id="reset" class="btn btn-primary btn-rounded  btn-bordered btn-sm" ><i class="fa fa-refresh"></i> 重置</a>
					 </div>
				</div>
			</form:form>
		</div>
	</div>
	
		<!-- 工具栏 -->
			<div id="toolbar">
				<shiro:hasPermission name="managementcenter:materialproject:del">
					<button id="remove" class="btn btn-danger" disabled onclick="deleteAll()">
						<i class="glyphicon glyphicon-remove"></i> 删除
					</button>
				</shiro:hasPermission>
				<shiro:hasPermission name="managementcenter:materialproject:import">
					<button id="btnImport" class="btn btn-info">
						<i class="fa fa-folder-open-o"></i> 导入
					</button>
				</shiro:hasPermission>
				<shiro:hasPermission name="managementcenter:materialproject:export">
						<button id="export" class="btn btn-warning">
						<i class="fa fa-file-excel-o"></i> 导出物料
					</button>
				 </shiro:hasPermission>
				<shiro:hasPermission name="managementcenter:materialproject:export">
					<button id="exportpro" class="btn btn-warning">
						<i class="fa fa-file-excel-o"></i> 导出项目
					</button>
				</shiro:hasPermission>
			</div>
		
	<!-- 表格 -->
	<table id="dataTable"  style="table-layout:fixed"   data-toolbar="#toolbar"></table>

    <!-- context menu -->
    <ul id="context-menu" class="dropdown-menu">
    	<shiro:hasPermission name="managementcenter:materialproject:add">
        <li data-item="view"><a>查看</a></li>
        </shiro:hasPermission>
    	<shiro:hasPermission name="managementcenter:materialproject:edit">
        <li data-item="edit"><a>编辑</a></li>
        </shiro:hasPermission>
        <shiro:hasPermission name="managementcenter:materialproject:del">
        <li data-item="delete"><a>删除</a></li>
        </shiro:hasPermission>
        <li data-item="action1"><a>取消</a></li>
    </ul>  
	</div>
	</div>
	</div>
</body>
</html>